import { ChangeDetectionStrategy, Component, EventEmitter, Input, Output, signal } from '@angular/core';
import { Product } from '../product-selection/product-selection.component';
import { FormsModule } from '@angular/forms';
import { ProductService } from '../services/product.service';

@Component({
  selector: 'app-product-quantity',
  standalone: true,
  imports: [FormsModule],
  templateUrl: './product-quantity.component.html',
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class ProductQuantityComponent {

  @Input({ required: true }) set product(value: Product | null) {
    this.productService.setProduct(value);
  }
  get product(): Product | null {
    return this.productService.getProduct();
  }

  @Output() quantityChange = new EventEmitter<number>();

  constructor(private productService: ProductService) {}

  get quantity(): number {
    return this.productService.getQuantity();
  }

  onQuantityChange(value: number) {
    this.productService.setQuantity(value);
    this.quantityChange.emit(value);
  }
}
